Unit AFP0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP0R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real);

implementation

procedure AFP0R(var A :Array of Real; N :Integer; M :Integer;
                var W :Array of Real);
var
I,J,B,F :Integer;
C,E,G,H,O,V,BG :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
for B:=1 to M do
 begin
  if ( B <> N ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := 0.0;
  goto _15;
_1:
  for I:=B to N do
   begin
    W[I-1] := A[(I-1)+(B-1)*N];
_2:
   end;
  C := 0.0;
  for I:=B to N do
   begin
    V := Abs(W[I-1]);
    if ( C >= V ) 
     then goto _3;
    C := V;
_3:
   end;
  if ( C = 0.0 ) 
   then goto _14;
  O := 1.0/C;
  G := 0.0;
  for I:=B to N do
   begin
    G := G+W[I-1]*O*W[I-1]*O;
_4:
   end;
  C := Sqrt(G)*C;
  G := 1.0/C;
  for I:=B to N do
   begin
    W[I-1] := W[I-1]*G;
_5:
   end;
  if ( W[B-1] <> 0.0 ) 
   then goto _6;
  H := 1.0;
  W[B-1] := 1.0;
  goto _8;
_6:
  H := Sign(1.0,W[B-1]);
  G := 1.0+Abs(W[B-1]);
  W[B-1] := H*G;
  G := 1.0/Sqrt(G);
  for I:=B to N do
   begin
    W[I-1] := W[I-1]*G;
_7:
   end;
_8:
  E := -C*H;
  for I:=B to N do
   begin
    A[(I-1)+(B-1)*N] := W[I-1];
_9:
   end;
  if ( B = M ) 
   then goto _13;
  F := B+1;
  for J:=F to M do
   begin
    BG := 0.0;
    for I:=B to N do
     begin
      BG := BG+A[(I-1)+(J-1)*N]*W[I-1];
_10:
     end;
    for I:=B to N do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BG*W[I-1];
_11:
     end;
_12:
   end;
_13:
  W[B-1] := E;
_14:
 end;
_15:
end;

end.
